//+------------------------------------------------------------------+
//|                                             Expected Volumes.mq4 |
//|                                     Copyright  2007, Amir Aliev |
//|                                       http://finmat.blogspot.com |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2007, Amir Aliev"
#property  link      "http://finmat.blogspot.com"
 
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Yellow

#property indicator_width1 2
#property indicator_width2 1
//---- input parameters
extern int hist_steps = 100;      // Number of observations
extern int span = 1;              // Days to step back each time 
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
int sum;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicators
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   
//----
   short_name = "Expected Hi-Lo(" + hist_steps + ")";
   IndicatorShortName(short_name);
   SetIndexLabel(0, short_name);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
   int rest = Bars - counted_bars;
   int j, k, u;
//----   
      
   while(rest >= 0)
   {
      if(Bars - rest < span * 23 * hist_steps) 
      {
         ExtMapBuffer1[rest] = 0;     
         rest--; 
         continue;                                   
      }
      sum = 0;
      j = 0;
      k = 0;
      u = 0;
      while(j < hist_steps && k < Bars) 
      {
         if(TimeHour(Time[rest+k]) == TimeHour(Time[rest]))
         {
            u++;
            if(u == span)
            {
               u = 0;
               j++;
               sum += (High[rest + k]-Low[rest + k])/Point; 
            }
            k += 23;
         }
         k++;
      }
      ExtMapBuffer1[rest] = sum / hist_steps;     
      ExtMapBuffer2[rest] = (High[rest]-Low[rest])/Point;
      rest--;                                    
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+